From fa71ebad223ba855783ad65a7faa0de2b5e9315a Mon Sep 17 00:00:00 2001
From: Carlo Della Giusta <carlo.dellagiusta@suse.com>
Date: Thu, 19 Jun 2025 10:04:58 +0200
Subject: [PATCH] Display correct advisory link by using an errata advisory map
 (bsc#1243808)

---
 .../rhn/common/conf/ConfigDefaults.java       |     17 +
 .../common/hibernate/AnnotationRegistry.java  |      4 +-
 .../test/ErrataDetailsSetupActionTest.java    |     31 +
 .../strings/java/StringResource_en_US.xml     |      6 +
 .../rhn/manager/channel/ChannelManager.java   |     21 +
 .../rhn/manager/errata/ErrataManager.java     |     39 +
 .../task/ErrataAdvisoryMapSync.java           |     67 +
 .../task/repomd/UpdateInfoWriter.java         |     33 +-
 .../manager/errata/ErrataParserFactory.java   |      2 +-
 .../errata/SUSEAdvisoryMapErrataParser.java   |     77 +
 .../advisorymap/ErrataAdvisoryMapManager.java |    157 +
 .../test/ErrataAdvisoryMapManagerTest.java    |     87 +
 .../errata/advisorymap/test/advisory-map.csv  | 140939 +++++++++++++++
 .../model/errata/ErrataAdvisoryMap.java       |    119 +
 .../errata/ErrataAdvisoryMapFactory.java      |     81 +
 .../errata/test/BaseErrataTestCase.java       |     20 +-
 .../test/SUSEAdvisoryMapErrataParserTest.java |    123 +
 java/conf/rhn_java.conf                       |      4 +
 ....Manager-4.3-fix-1243808-suse-advisory-url |      2 +
 .../spacewalk/common/data/rhnTaskoBunch.sql   |      3 +
 .../common/data/rhnTaskoSchedule.sql          |      6 +
 schema/spacewalk/common/data/rhnTaskoTask.sql |      3 +
 .../common/data/rhnTaskoTemplate.sql          |      7 +
 .../common/tables/suseErrataAdvisoryMap.sql   |     29 +
 schema/spacewalk/postgres/data/reschedule.sql |      3 +-
 ....Manager-4.3-fix-1243808-suse-advisory-url |      1 +
 ....carlo.uyuni-fix-1243808-suse-advisory-url |      3 +
 .../100-create-suseErrataAdvisoryMap.sql      |     29 +
 .../101-errata-advisory-map-taskomatic.sql    |     52 +
 ...ata-advisory-map-taskomatic-reschedule.sql |     12 +
 .../scripts/pre_idempotency_test_query.sql    |     15 +
 .../scripts/schema_idempotency_test_pgsql.py  |     19 +
 32 files changed, 141973 insertions(+), 38 deletions(-)
 create mode 100644 java/code/src/com/redhat/rhn/taskomatic/task/ErrataAdvisoryMapSync.java
 create mode 100644 java/code/src/com/suse/manager/errata/SUSEAdvisoryMapErrataParser.java
 create mode 100644 java/code/src/com/suse/manager/errata/advisorymap/ErrataAdvisoryMapManager.java
 create mode 100644 java/code/src/com/suse/manager/errata/advisorymap/test/ErrataAdvisoryMapManagerTest.java
 create mode 100644 java/code/src/com/suse/manager/errata/advisorymap/test/advisory-map.csv
 create mode 100644 java/code/src/com/suse/manager/errata/model/errata/ErrataAdvisoryMap.java
 create mode 100644 java/code/src/com/suse/manager/errata/model/errata/ErrataAdvisoryMapFactory.java
 create mode 100644 java/code/src/com/suse/manager/errata/test/SUSEAdvisoryMapErrataParserTest.java
 create mode 100644 java/spacewalk-java.changes.carlo.Manager-4.3-fix-1243808-suse-advisory-url
 create mode 100644 schema/spacewalk/common/tables/suseErrataAdvisoryMap.sql
 create mode 100644 schema/spacewalk/susemanager-schema.changes.carlo.Manager-4.3-fix-1243808-suse-advisory-url
 create mode 100644 schema/spacewalk/susemanager-schema.changes.carlo.uyuni-fix-1243808-suse-advisory-url
 create mode 100644 schema/spacewalk/upgrade/susemanager-schema-4.3.28-to-susemanager-schema-4.3.29/100-create-suseErrataAdvisoryMap.sql
 create mode 100644 schema/spacewalk/upgrade/susemanager-schema-4.3.28-to-susemanager-schema-4.3.29/101-errata-advisory-map-taskomatic.sql
 create mode 100644 schema/spacewalk/upgrade/susemanager-schema-4.3.28-to-susemanager-schema-4.3.29/102-errata-advisory-map-taskomatic-reschedule.sql
 create mode 100644 susemanager-utils/testing/docker/scripts/pre_idempotency_test_query.sql

diff --git a/java/code/src/com/redhat/rhn/common/conf/ConfigDefaults.java b/java/code/src/com/redhat/rhn/common/conf/ConfigDefaults.java
index bf6ee2816e4a..54c8ede30a7a 100644
--- a/java/code/src/com/redhat/rhn/common/conf/ConfigDefaults.java
+++ b/java/code/src/com/redhat/rhn/common/conf/ConfigDefaults.java
@@ -1,4 +1,5 @@
 /*
+ * Copyright (c) 2025 SUSE LLC
  * Copyright (c) 2009--2014 Red Hat, Inc.
  *
  * This software is licensed to you under the GNU General Public License,
@@ -380,6 +381,12 @@ public class ConfigDefaults {
      */
     public static final String RHUI_DEFAULT_ORG_ID = "java.rhui_default_org_id";
 
+    /**
+     * url to download advisory-map.csv, the map of errata patch id, announcement id and advisory URL
+     */
+    private static final String ERRATA_ADVISORY_MAP_CSV_DOWNLOAD_URL = "java.errata_advisory_map_csv_download_url";
+
+
     private ConfigDefaults() {
     }
 
@@ -1148,4 +1155,14 @@ public boolean isCustomChannelManagementUnificationEnabled() {
     public long getRhuiDefaultOrgId() {
         return Config.get().getInt(RHUI_DEFAULT_ORG_ID, 1);
     }
+
+    /**
+     * Return the url to download advisory-map.csv, the map of errata patch id, announcement id and advisory URL
+     *
+     * @return the url to download advisory-map.csv, the map of errata patch id, announcement id and advisory URL
+     */
+    public String getErrataAdvisoryMapCsvDownloadUrl() {
+        return Config.get().getString(ERRATA_ADVISORY_MAP_CSV_DOWNLOAD_URL,
+                "https://ftp.suse.com/pub/projects/security/advisory-map.csv");
+    }
 }
diff --git a/java/code/src/com/redhat/rhn/common/hibernate/AnnotationRegistry.java b/java/code/src/com/redhat/rhn/common/hibernate/AnnotationRegistry.java
index 74b5becd8e0e..5c899e8b5ba3 100644
--- a/java/code/src/com/redhat/rhn/common/hibernate/AnnotationRegistry.java
+++ b/java/code/src/com/redhat/rhn/common/hibernate/AnnotationRegistry.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2018 SUSE LLC
+ * Copyright (c) 2018--2025 SUSE LLC
  *
  * This software is licensed to you under the GNU General Public License,
  * version 2 (GPLv2). There is NO WARRANTY for this software, express or
@@ -90,6 +90,7 @@
 
 import com.suse.cloud.domain.PaygDimensionComputation;
 import com.suse.cloud.domain.PaygDimensionResult;
+import com.suse.manager.errata.model.errata.ErrataAdvisoryMap;
 import com.suse.manager.model.maintenance.MaintenanceCalendar;
 import com.suse.manager.model.maintenance.MaintenanceSchedule;
 
@@ -143,6 +144,7 @@ private AnnotationRegistry() {
         ModuleFilter.class,
         PtfFilter.class,
         EnvironmentTarget.class,
+        ErrataAdvisoryMap.class,
         SoftwareEnvironmentTarget.class,
         ContentProjectHistoryEntry.class,
         PackageExtraTagsKeys.class,
diff --git a/java/code/src/com/redhat/rhn/frontend/action/errata/test/ErrataDetailsSetupActionTest.java b/java/code/src/com/redhat/rhn/frontend/action/errata/test/ErrataDetailsSetupActionTest.java
index b9101fa486ba..cef05e6090e8 100644
--- a/java/code/src/com/redhat/rhn/frontend/action/errata/test/ErrataDetailsSetupActionTest.java
+++ b/java/code/src/com/redhat/rhn/frontend/action/errata/test/ErrataDetailsSetupActionTest.java
@@ -17,24 +17,52 @@
 import static org.junit.jupiter.api.Assertions.assertEquals;
 import static org.junit.jupiter.api.Assertions.assertNotNull;
 
+import com.redhat.rhn.domain.channel.Channel;
+import com.redhat.rhn.domain.channel.test.ChannelFactoryTest;
 import com.redhat.rhn.domain.errata.AdvisoryStatus;
 import com.redhat.rhn.domain.errata.Errata;
 import com.redhat.rhn.domain.errata.ErrataFactory;
 import com.redhat.rhn.domain.errata.test.ErrataFactoryTest;
 import com.redhat.rhn.frontend.action.errata.ErrataDetailsSetupAction;
+import com.redhat.rhn.frontend.context.Context;
 import com.redhat.rhn.testing.ActionHelper;
 import com.redhat.rhn.testing.RhnBaseTestCase;
 
+import com.suse.manager.errata.advisorymap.ErrataAdvisoryMapManager;
+
+import org.junit.jupiter.api.BeforeEach;
 import org.junit.jupiter.api.Test;
 
+import java.io.ByteArrayInputStream;
+import java.io.InputStream;
+import java.nio.charset.StandardCharsets;
 import java.util.Calendar;
 import java.util.GregorianCalendar;
+import java.util.Locale;
 
 /**
  * ErrataDetailsSetupActionTest
  */
 public class ErrataDetailsSetupActionTest extends RhnBaseTestCase {
 
+    @BeforeEach
+    @Override
+    public void setUp() throws Exception {
+        super.setUp();
+
+        // Set the locale explicitly to check the dates in an known format
+        Context.getCurrentContext().setLocale(Locale.US);
+
+        String testAdvisoryMapCsv =
+                "# patchid, notice id, url\n" +
+                "SUSE-SLE-Module-Basesystem-15-SP3-2021-3413,SUSE-RU-2021:3413-1," +
+                "https://www.suse.com/support/update/announcement/2021/suse-ru-20213413-1/\n";
+
+        InputStream inputStream = new ByteArrayInputStream(testAdvisoryMapCsv.getBytes(StandardCharsets.UTF_8));
+        ErrataAdvisoryMapManager amm = new ErrataAdvisoryMapManager();
+        amm.readAdvisoryMapPopulateDatabase(inputStream);
+    }
+
     @Test
     public void testExecute() throws Exception {
         ErrataDetailsSetupAction action = new ErrataDetailsSetupAction();
@@ -55,6 +83,9 @@ public void testExecute() throws Exception {
         errata.setUpdateDate(new GregorianCalendar(2021, Calendar.OCTOBER, 13).getTime());
         errata.setErrataFrom("maint-coord@suse.de");
         errata.addKeyword("test");
+        Channel ch = ChannelFactoryTest.createTestChannel(sah.getUser().getOrg());
+        ch.setUpdateTag("SLE-Module-Basesystem");
+        errata.addChannel(ch);
 
         ErrataFactory.save(errata);
 
diff --git a/java/code/src/com/redhat/rhn/manager/channel/ChannelManager.java b/java/code/src/com/redhat/rhn/manager/channel/ChannelManager.java
index a33350d02dd7..352130c79954 100644
--- a/java/code/src/com/redhat/rhn/manager/channel/ChannelManager.java
+++ b/java/code/src/com/redhat/rhn/manager/channel/ChannelManager.java
@@ -2939,4 +2939,25 @@ public static void analyzeChannelPackages() {
         var m = ModeFactory.getCallableMode("Channel_queries", "analyze_channel_packages");
         m.execute(new HashMap<>(), new HashMap<>());
     }
+
+    /**
+     * Find the update tag for a given channel looking also at original channels
+     * in case the given channel is a clone.
+     * @param channel channel
+     * @return update tag or null
+     */
+    public static String findUpdateTag(Channel channel) {
+        String updateTag = channel.getUpdateTag();
+        if (StringUtils.isEmpty(updateTag)) {
+            Channel current = channel;
+            while (current.isCloned()) {
+                current = current.asCloned().map(ClonedChannel::getOriginal).orElseThrow();
+                updateTag = current.getUpdateTag();
+                if (updateTag != null && !updateTag.isEmpty()) {
+                    break;
+                }
+            }
+        }
+        return updateTag;
+    }
 }
diff --git a/java/code/src/com/redhat/rhn/manager/errata/ErrataManager.java b/java/code/src/com/redhat/rhn/manager/errata/ErrataManager.java
index f993bdf2b829..d86b1a82f659 100644
--- a/java/code/src/com/redhat/rhn/manager/errata/ErrataManager.java
+++ b/java/code/src/com/redhat/rhn/manager/errata/ErrataManager.java
@@ -2283,4 +2283,43 @@ public static void updateErrataSet(Long serverId) {
         WriteMode m = ModeFactory.getWriteMode("Errata_queries", "delete_invalid_erratas_from_set");
         m.executeUpdate(params);
     }
+
+    /**
+     * computes the patch id string, given an errata and a channel
+     *
+     * @param errata  the errata
+     * @param channel the channel
+     * @return the computed patch id
+     */
+    public static String getPatchId(Errata errata, Channel channel) {
+        if ((null == errata) || (null == channel)) {
+            return "";
+        }
+        return getPatchId(errata.getAdvisory(), channel);
+    }
+
+    /**
+     * computes the patch id string, given an errata and a channel
+     *
+     * @param errataAdvisory  the errata advisory string
+     * @param channel the channel
+     * @return the computed patch id
+     */
+    public static String getPatchId(String errataAdvisory, Channel channel) {
+        if (null == channel) {
+            return "";
+        }
+        String patchId = StringUtils.isEmpty(errataAdvisory) ? "" : errataAdvisory;
+        String updateTag = ChannelManager.findUpdateTag(channel);
+        if (!StringUtils.isEmpty(updateTag)) {
+            if (patchId.matches("^([C-Z][A-Z]-)*SUSE-(.*)$")) {
+                // SLE12 style where the update tag is not a prefix
+                patchId = patchId.replaceFirst("SUSE", "SUSE-" + updateTag);
+            }
+            else {
+                patchId = updateTag + "-" + patchId;
+            }
+        }
+        return patchId;
+    }
 }
diff --git a/java/code/src/com/redhat/rhn/taskomatic/task/ErrataAdvisoryMapSync.java b/java/code/src/com/redhat/rhn/taskomatic/task/ErrataAdvisoryMapSync.java
new file mode 100644
index 000000000000..b7b8c10b00e0
--- /dev/null
+++ b/java/code/src/com/redhat/rhn/taskomatic/task/ErrataAdvisoryMapSync.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2025 SUSE LLC
+ *
+ * This software is licensed to you under the GNU General Public License,
+ * version 2 (GPLv2). There is NO WARRANTY for this software, express or
+ * implied, including the implied warranties of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. You should have received a copy of GPLv2
+ * along with this software; if not, see
+ * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
+ *
+ * Red Hat trademarks are not licensed under GPLv2. No permission is
+ * granted to use or replicate Red Hat trademarks that are incorporated
+ * in this software or its documentation.
+ */
+
+package com.redhat.rhn.taskomatic.task;
+
+import com.suse.manager.errata.advisorymap.ErrataAdvisoryMapManager;
+
+import org.quartz.JobExecutionContext;
+import org.quartz.JobExecutionException;
+
+import java.io.IOException;
+
+/**
+ * Update SUSE errata advisory map to retrieve announcement ids and advisor URLs
+ * */
+public class ErrataAdvisoryMapSync extends RhnJavaJob {
+
+    /**
+     * default constructor
+     */
+    public ErrataAdvisoryMapSync() {
+        this(new ErrataAdvisoryMapManager());
+    }
+
+    /**
+     * constructor
+     *
+     * @param advisoryMapManagerIn an instance of ErrataAdvisoryMapManager.
+     */
+    public ErrataAdvisoryMapSync(ErrataAdvisoryMapManager advisoryMapManagerIn) {
+        this.advisoryMapManager = advisoryMapManagerIn;
+    }
+
+    private final ErrataAdvisoryMapManager advisoryMapManager;
+
+
+    @Override
+    public String getConfigNamespace() {
+        return "errata_advisory_map_sync";
+    }
+
+    @Override
+    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
+        log.info("Updates SUSE errata advisory map");
+
+        try {
+            advisoryMapManager.syncErrataAdvisoryMap();
+        }
+        catch (IOException eIn) {
+            log.info("Error while updating SUSE errata advisory map", eIn);
+        }
+
+        log.info("Done Updates SUSE errata advisory map");
+    }
+}
diff --git a/java/code/src/com/redhat/rhn/taskomatic/task/repomd/UpdateInfoWriter.java b/java/code/src/com/redhat/rhn/taskomatic/task/repomd/UpdateInfoWriter.java
index c9e370a373cf..5b2a46bdfa6b 100644
--- a/java/code/src/com/redhat/rhn/taskomatic/task/repomd/UpdateInfoWriter.java
+++ b/java/code/src/com/redhat/rhn/taskomatic/task/repomd/UpdateInfoWriter.java
@@ -113,17 +113,7 @@ private void addErratum(ErrataOverview erratum, Channel channel) throws SAXExcep
         attr.addAttribute("version", Long.toString(erratum.getAdvisoryRel()));
         handler.startElement("update", attr);
 
-        String id = erratum.getAdvisoryName();
-        String updateTag = findUpdateTag(channel);
-        if (updateTag != null) {
-            if (id.matches("^([C-Z][A-Z]-)*SUSE-(.*)$")) {
-                // SLE12 style where the update tag is not a prefix
-                id = id.replaceFirst("SUSE", "SUSE-" + updateTag);
-            }
-            else {
-                id = updateTag + "-" + id;
-            }
-        }
+        String id = ErrataManager.getPatchId(erratum.getAdvisoryName(), channel);
 
         handler.addElementWithCharacters("id", sanitize(0L, id));
         handler.addElementWithCharacters("title", sanitize(0L, erratum.getAdvisorySynopsis()));
@@ -267,25 +257,4 @@ else if (advisoryType.equals("Security Advisory")) {
             return "errata";
         }
     }
-
-    /**
-     * Find the update tag for a given channel looking also at original channels
-     * in case the given channel is a clone.
-     * @param channel channel
-     * @return update tag or null
-     */
-    private String findUpdateTag(Channel channel) {
-        String updateTag = channel.getUpdateTag();
-        if (updateTag == null || updateTag.isEmpty()) {
-            Channel current = channel;
-            while (current.isCloned()) {
-                current = current.getOriginal();
-                updateTag = current.getUpdateTag();
-                if (updateTag != null && !updateTag.isEmpty()) {
-                    break;
-                }
-            }
-        }
-        return updateTag;
-    }
 }
diff --git a/java/code/src/com/suse/manager/errata/ErrataParserFactory.java b/java/code/src/com/suse/manager/errata/ErrataParserFactory.java
index 7e613b500c23..a9fa703fc523 100644
--- a/java/code/src/com/suse/manager/errata/ErrataParserFactory.java
+++ b/java/code/src/com/suse/manager/errata/ErrataParserFactory.java
@@ -37,7 +37,7 @@ private enum SupportedVendor {
         REDHAT("release-engineering@redhat.com", RedhatErrataParser::new),
         ROCKYLINUX("releng@rockylinux.org", RockyLinuxErrataParser::new),
         SUSE_RES("res-maintenance@suse.de", SUSERESErrataParser::new),
-        SUSE("maint-coord@suse.de", SUSEErrataParser::new);
+        SUSE("maint-coord@suse.de", SUSEAdvisoryMapErrataParser::new);
 
         /** Email used in the errata */
         private final String vendorEmail;
diff --git a/java/code/src/com/suse/manager/errata/SUSEAdvisoryMapErrataParser.java b/java/code/src/com/suse/manager/errata/SUSEAdvisoryMapErrataParser.java
new file mode 100644
index 000000000000..7d4525571324
--- /dev/null
+++ b/java/code/src/com/suse/manager/errata/SUSEAdvisoryMapErrataParser.java
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2025 SUSE LLC
+ *
+ * This software is licensed to you under the GNU General Public License,
+ * version 2 (GPLv2). There is NO WARRANTY for this software, express or
+ * implied, including the implied warranties of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. You should have received a copy of GPLv2
+ * along with this software; if not, see
+ * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
+ *
+ */
+package com.suse.manager.errata;
+
+import com.redhat.rhn.domain.errata.Errata;
+import com.redhat.rhn.manager.errata.ErrataManager;
+
+
+import com.suse.manager.errata.model.errata.ErrataAdvisoryMap;
+import com.suse.manager.errata.model.errata.ErrataAdvisoryMapFactory;
+
+import java.net.URI;
+import java.net.URISyntaxException;
+
+public class SUSEAdvisoryMapErrataParser implements VendorSpecificErrataParser {
+
+    /**
+     * default constructor
+     */
+    public SUSEAdvisoryMapErrataParser() {
+        this(new ErrataAdvisoryMapFactory());
+    }
+
+    /**
+     * constructor
+     *
+     * @param advisoryMapFactoryIn an instance of ErrataAdvisoryMapFactory.
+     */
+    public SUSEAdvisoryMapErrataParser(ErrataAdvisoryMapFactory advisoryMapFactoryIn) {
+        this.advisoryMapFactory = advisoryMapFactoryIn;
+    }
+
+    private final ErrataAdvisoryMapFactory advisoryMapFactory;
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public URI getAdvisoryUri(Errata errata) throws ErrataParsingException {
+        try {
+            String uri = errata.getChannels().stream()
+                .map(ch -> ErrataManager.getPatchId(errata, ch))
+                .flatMap(s -> advisoryMapFactory.lookupByPatchId(s).stream())
+                .map(ErrataAdvisoryMap::getAdvisoryUri)
+                .findFirst()
+                .orElseThrow(() -> new ErrataParsingException(
+                        "Unable generate announcement vendor link for errata: " + errata.getAdvisory()));
+            return new URI(uri);
+        }
+        catch (URISyntaxException ex) {
+            throw new ErrataParsingException("Unable to generate vendor link for errata " + errata.getAdvisory(), ex);
+        }
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public String getAnnouncementId(Errata errata) throws ErrataParsingException {
+        return errata.getChannels().stream()
+                .map(ch -> ErrataManager.getPatchId(errata, ch))
+                .flatMap(s -> advisoryMapFactory.lookupByPatchId(s).stream())
+                .map(ErrataAdvisoryMap::getAnnouncementId)
+                .findFirst()
+                .orElseThrow(() -> new ErrataParsingException(
+                        "Unable to generate announcement id for errata: " + errata.getAdvisory()));
+    }
+}
diff --git a/java/code/src/com/suse/manager/errata/advisorymap/ErrataAdvisoryMapManager.java b/java/code/src/com/suse/manager/errata/advisorymap/ErrataAdvisoryMapManager.java
new file mode 100644
index 000000000000..17cbc7c2bb83
--- /dev/null
+++ b/java/code/src/com/suse/manager/errata/advisorymap/ErrataAdvisoryMapManager.java
@@ -0,0 +1,157 @@
+/*
+ * Copyright (c) 2025 SUSE LLC
+ *
+ * This software is licensed to you under the GNU General Public License,
+ * version 2 (GPLv2). There is NO WARRANTY for this software, express or
+ * implied, including the implied warranties of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. You should have received a copy of GPLv2
+ * along with this software; if not, see
+ * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
+ */
+package com.suse.manager.errata.advisorymap;
+
+import com.redhat.rhn.common.conf.ConfigDefaults;
+import com.redhat.rhn.common.util.http.HttpClientAdapter;
+
+import com.suse.manager.errata.model.errata.ErrataAdvisoryMap;
+import com.suse.manager.errata.model.errata.ErrataAdvisoryMapFactory;
+
+import org.apache.http.HttpResponse;
+import org.apache.http.HttpStatus;
+import org.apache.http.client.methods.HttpGet;
+import org.apache.http.client.methods.HttpRequestBase;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import java.io.BufferedReader;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.net.NoRouteToHostException;
+import java.net.URI;
+import java.net.URISyntaxException;
+
+public class ErrataAdvisoryMapManager {
+
+    private final ErrataAdvisoryMapFactory advisoryMapFactory;
+
+    private static final Logger LOG = LogManager.getLogger(ErrataAdvisoryMapManager.class);
+
+    private static final String ADVISORY_MAP_CSV_DELIMITER = ",";
+
+    /**
+     * Default constructor
+     */
+    public ErrataAdvisoryMapManager() {
+        this(new ErrataAdvisoryMapFactory());
+    }
+
+    /**
+     * Builds an instance with the given dependencies
+     *
+     * @param advisoryMapFactoryIn the errata advisory map factory
+     */
+    public ErrataAdvisoryMapManager(ErrataAdvisoryMapFactory advisoryMapFactoryIn) {
+        this.advisoryMapFactory = advisoryMapFactoryIn;
+    }
+
+    /**
+     * Returns the advisory map size
+     *
+     * @return the advisory map size
+     */
+    public long getAdvisoryMapSize() {
+        return advisoryMapFactory.count();
+    }
+
+    /**
+     * parses an advisory map csv file, saving the entries in the database
+     * <p>
+     * the advisory map csv file has the following structure:
+     * a) first row has headers
+     * b) each row represents an entry
+     * c) each entry row contains fields, coma (",") separated
+     * d) first field is the advisory (e.g. "SUSE-SLE-Module-Basesystem-15-SP6-2025-1733")
+     * e) second field is the announcementId (e.g. "SUSE-RU-2025:01733-1")
+     * f) third field (optional) is the advisoryUri
+     * (e.g. "https://www.suse.com/support/update/announcement/2025/suse-ru-202501733-1")
+     *
+     * @param inputStreamIn the errata advisory map input stream
+     */
+    public void readAdvisoryMapPopulateDatabase(InputStream inputStreamIn) throws IOException {
+        try (BufferedReader br = new BufferedReader(new InputStreamReader(inputStreamIn))) {
+            String line;
+            boolean firstLine = true;
+            while ((line = br.readLine()) != null) {
+                if (firstLine) {
+                    //skip first line (headers) and clear database
+                    advisoryMapFactory.clearErrataAdvisoryMap();
+                }
+                else {
+                    String[] advisoryItem = line.split(ADVISORY_MAP_CSV_DELIMITER);
+
+                    String advisory = (advisoryItem.length > 0 ? advisoryItem[0] : "");
+                    String announcementId = (advisoryItem.length > 1 ? advisoryItem[1] : "");
+                    String advisoryUri = (advisoryItem.length > 2 ? advisoryItem[2] : "");
+
+                    ErrataAdvisoryMap advisoryMapEntry = new ErrataAdvisoryMap(advisory, announcementId, advisoryUri);
+                    advisoryMapFactory.save(advisoryMapEntry);
+                }
+                firstLine = false;
+            }
+        }
+    }
+
+    /**
+     * Synchronizes the advisory map
+     * Downloads the advisory map, parses the csv file and saves the entries in the database
+     */
+    public void syncErrataAdvisoryMap() throws IOException {
+        String downloadUrl = ConfigDefaults.get().getErrataAdvisoryMapCsvDownloadUrl();
+
+        URI advisoryMapURI = null;
+        try {
+            advisoryMapURI = new URI(downloadUrl);
+        }
+        catch (URISyntaxException ex) {
+            LOG.error("Unable to create advisory map url: {} {}.", downloadUrl, ex.getMessage());
+        }
+
+        HttpClientAdapter httpClient = new HttpClientAdapter();
+
+        HttpRequestBase request = null;
+        try {
+            request = new HttpGet(advisoryMapURI);
+
+            // Connect and parse the response on success
+            HttpResponse response = httpClient.executeRequest(request);
+            int responseCode = response.getStatusLine().getStatusCode();
+
+            if (responseCode == HttpStatus.SC_OK) {
+                try (InputStream inputStream = response.getEntity().getContent()) {
+                    readAdvisoryMapPopulateDatabase(inputStream);
+                }
+            }
+            else {
+                // Request was not successful
+                String errorString = "Unable to get content for advisory map request: response code " + responseCode +
+                        " connecting to " + request.getURI();
+                LOG.error(errorString);
+                throw new IOException(errorString);
+            }
+        }
+        catch (NoRouteToHostException ex) {
+            String proxy = ConfigDefaults.get().getProxyHost();
+            String errorString = "No route to download advisory map" + (proxy != null ? " or the Proxy: " + proxy : "");
+            LOG.error(errorString, ex);
+            throw new IOException(errorString);
+        }
+        catch (IOException ioEx) {
+            LOG.error("Unable to get content for advisory map request: {} {}", downloadUrl, ioEx);
+            throw ioEx;
+        }
+        finally {
+            request.releaseConnection();
+        }
+    }
+}
diff --git a/java/code/src/com/suse/manager/errata/advisorymap/test/ErrataAdvisoryMapManagerTest.java b/java/code/src/com/suse/manager/errata/advisorymap/test/ErrataAdvisoryMapManagerTest.java
new file mode 100644
index 000000000000..a808ca68ede3
--- /dev/null
+++ b/java/code/src/com/suse/manager/errata/advisorymap/test/ErrataAdvisoryMapManagerTest.java
@@ -0,0 +1,87 @@
+/*
+ * Copyright (c) 2025 SUSE LLC
+ *
+ * This software is licensed to you under the GNU General Public License,
+ * version 2 (GPLv2). There is NO WARRANTY for this software, express or
+ * implied, including the implied warranties of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. You should have received a copy of GPLv2
+ * along with this software; if not, see
+ * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
+ */
+
+package com.suse.manager.errata.advisorymap.test;
+
+import static org.junit.jupiter.api.Assertions.assertEquals;
+import static org.junit.jupiter.api.Assertions.assertTrue;
+
+import com.redhat.rhn.testing.RhnBaseTestCase;
+
+import com.suse.manager.errata.advisorymap.ErrataAdvisoryMapManager;
+
+import org.junit.jupiter.api.Test;
+
+import java.io.IOException;
+import java.io.InputStream;
+
+public class ErrataAdvisoryMapManagerTest extends RhnBaseTestCase {
+    private static final String TEST_ADVISORY_MAP_CSV_FILE_NAME =
+            "/com/suse/manager/errata/advisorymap/test/advisory-map.csv";
+    private static final long TEST_ADVISORY_MAP_RECORDS_NUM = 140938L;
+
+    private static final boolean PRINT_STD_OUTPUT = false;
+    private static final boolean PERFORM_LONG_TESTS = false;
+    private long startTimeMs;
+
+    private final ErrataAdvisoryMapManager advisoryMapManager = new ErrataAdvisoryMapManager();
+
+    @SuppressWarnings("java:S106")
+    private static void testPrintOut(String arg) {
+        if (!PRINT_STD_OUTPUT) {
+            return;
+        }
+        System.out.println(arg);
+    }
+
+    private void startTimeMeasure(String message) {
+        testPrintOut(message);
+        startTimeMs = System.currentTimeMillis();
+    }
+
+    private void stopTimeMeasure(String message) {
+        long estimatedTimeMs = System.currentTimeMillis() - startTimeMs;
+        testPrintOut(message + String.format("%d seconds (%d ms)", estimatedTimeMs / 1000L, estimatedTimeMs));
+    }
+
+    @Test
+    public void storeNewAdvisoryMapLongTest() throws IOException {
+        if (PERFORM_LONG_TESTS) {
+            //test time: about 20 seconds for 140K records
+            assertEquals(0, advisoryMapManager.getAdvisoryMapSize());
+
+            InputStream inputStream = this.getClass().getResourceAsStream(TEST_ADVISORY_MAP_CSV_FILE_NAME);
+
+            startTimeMeasure(String.format("Populating EMPTY ErrataAdvisoryMap with %d records",
+                    TEST_ADVISORY_MAP_RECORDS_NUM));
+            advisoryMapManager.readAdvisoryMapPopulateDatabase(inputStream);
+            stopTimeMeasure("Elapsed time: ");
+
+            assertEquals(TEST_ADVISORY_MAP_RECORDS_NUM, advisoryMapManager.getAdvisoryMapSize());
+        }
+    }
+
+    @Test
+    public void syncErrataAdvisoryMapTest() throws IOException {
+        if (PERFORM_LONG_TESTS) {
+            //download time: about 5 seconds for about 140K records
+            //populate records time: about 20 seconds for 140K records
+            assertEquals(0, advisoryMapManager.getAdvisoryMapSize());
+
+            startTimeMeasure("Synchronize ErrataAdvisoryMap and populate database");
+            advisoryMapManager.syncErrataAdvisoryMap();
+            stopTimeMeasure("Elapsed time: ");
+
+            testPrintOut(String.format("Num records: %d", advisoryMapManager.getAdvisoryMapSize()));
+            assertTrue(advisoryMapManager.getAdvisoryMapSize() > 140000);
+        }
+    }
+}
